'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _LogsRouter3 = require('parse-server/lib/Routers/LogsRouter');

var _middlewares = require('parse-server/lib/middlewares');

var middlewares = _interopRequireWildcard(_middlewares);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LogsRouter = function (_LogsRouter2) {
    _inherits(LogsRouter, _LogsRouter2);

    function LogsRouter() {
        _classCallCheck(this, LogsRouter);

        return _possibleConstructorReturn(this, (LogsRouter.__proto__ || Object.getPrototypeOf(LogsRouter)).apply(this, arguments));
    }

    _createClass(LogsRouter, [{
        key: 'handleGET',
        value: function handleGET(req) {
            var startTime = req.query.startTime;
            if (startTime) {
                startTime = JSON.parse(startTime);
                if (startTime.__type === 'Date') {
                    startTime = startTime.iso;
                }
                req.query.from = startTime;
            }
            return _get(LogsRouter.prototype.__proto__ || Object.getPrototypeOf(LogsRouter.prototype), 'handleGET', this).call(this, req).then(function (response) {
                // remove logs exactly at startTime
                response.response = response.response.filter(function (log) {
                    return log.timestamp != startTime;
                });
                return response;
            }).then(this._patchResponse);
        }
    }, {
        key: '_patchResponse',
        value: function _patchResponse(response) {
            response.response.forEach(function (log) {
                log.timestamp = {
                    __type: 'Date',
                    iso: log.timestamp
                };
            });
            return response;
        }
    }, {
        key: 'mountOnto',
        value: function mountOnto(app) {
            app.use('/scriptlog', middlewares.handleParseHeaders);
            return _get(LogsRouter.prototype.__proto__ || Object.getPrototypeOf(LogsRouter.prototype), 'mountOnto', this).call(this, app);
        }
    }]);

    return LogsRouter;
}(_LogsRouter3.LogsRouter);

exports.default = LogsRouter;