'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ParseCliServer = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _express = require('express');

var _express2 = _interopRequireDefault(_express);

var _bodyParser = require('body-parser');

var _bodyParser2 = _interopRequireDefault(_bodyParser);

var _cache = require('parse-server/lib/cache');

var _cache2 = _interopRequireDefault(_cache);

var _ParseCliController = require('./ParseCliController');

var _ParseCliController2 = _interopRequireDefault(_ParseCliController);

var _ParseCliRouter = require('./ParseCliRouter');

var _ParseCliRouter2 = _interopRequireDefault(_ParseCliRouter);

var _FunctionsRouter = require('./FunctionsRouter');

var _FunctionsRouter2 = _interopRequireDefault(_FunctionsRouter);

var _HooksRouter = require('./HooksRouter');

var _HooksRouter2 = _interopRequireDefault(_HooksRouter);

var _LogsRouter = require('./LogsRouter');

var _LogsRouter2 = _interopRequireDefault(_LogsRouter);

var _VendorAdapter = require('./VendorAdapter');

var _VendorAdapter2 = _interopRequireDefault(_VendorAdapter);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ParseCliServer = function () {
  function ParseCliServer(_ref) {
    var config = _ref.config,
        vendorAdapter = _ref.vendorAdapter,
        cloud = _ref.cloud,
        public_html = _ref.public_html;

    _classCallCheck(this, ParseCliServer);

    this.length_limit = '500mb';

    if (config) {
      _cache2.default.put(config.applicationId, config);
      if (config.limit !== undefined) {
        this.length_limit = config.limit;
      }
    }

    if (!vendorAdapter) {
      vendorAdapter = new _VendorAdapter2.default({
        config: config,
        cloud: cloud,
        public_html: public_html
      });
    }
    var controller = new _ParseCliController2.default(vendorAdapter);
    this.router = new _ParseCliRouter2.default(controller);
  }

  _createClass(ParseCliServer, [{
    key: 'app',
    get: function get() {
      var app = (0, _express2.default)();
      /*
      parse-cli always send json body but don't send a Content-Type
      header or in some cases send an unexpected value like
      application/octet-stream.
      express request length limit is very low. Change limit value
      for fix 'big' files deploy problems.
      */
      app.use(_bodyParser2.default.json({ type: function type() {
          return true;
        }, limit: this.length_limit }));

      this.router.mountOnto(app);

      var functionsRouter = new _FunctionsRouter2.default();
      functionsRouter.mountOnto(app);

      var hooksRouter = new _HooksRouter2.default();
      hooksRouter.mountOnto(app);

      var logsRouter = new _LogsRouter2.default();
      logsRouter.mountOnto(app);

      return app;
    }
  }]);

  return ParseCliServer;
}();

exports.default = ParseCliServer;
exports.ParseCliServer = ParseCliServer;